DECLARE @stringId AS int;
DECLARE @cultureId AS int;

-- Get culture ID
SET @cultureID = (SELECT UICultureID FROM [CMS_UICulture] WHERE UICultureCode='en-US');

-- Delete existing resource string and translations
DELETE FROM [CMS_ResourceTranslation] WHERE TranslationStringID IN (SELECT StringID FROM [CMS_ResourceString] WHERE StringKey='ObjectTasks.__MEDIALIBRARY__')
DELETE FROM [CMS_ResourceString] WHERE StringKey='ObjectTasks.__MEDIALIBRARY__'
	
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('ObjectTasks.__MEDIALIBRARY__'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Media libraries')

-- Delete existing resource string and translations
DELETE FROM [CMS_ResourceTranslation] WHERE TranslationStringID IN (SELECT StringID FROM [CMS_ResourceString] WHERE StringKey='ObjectType.Media_File')
DELETE FROM [CMS_ResourceString] WHERE StringKey='ObjectType.Media_File'
           
-- Insert resource string
INSERT INTO [CMS_ResourceString]
           ([StringKey]
           ,[StringIsCustom]
           ,[StringLoadGeneration])
     VALUES
           ('ObjectType.Media_File'
           ,0
           ,0)

SET @stringId = scope_identity();

-- Insert translation
INSERT INTO [CMS_ResourceTranslation]
           ([TranslationStringID]
           ,[TranslationUICultureID]
           ,[TranslationText])
     VALUES
           (@stringId
           ,@cultureId
           ,'Media file')          
GO 


ALTER PROCEDURE [Proc_Community_Group_RemoveDependencies]	
	@GroupID int
AS
BEGIN	
	SET NOCOUNT ON;

    -- Get AvatarID from current group
    DECLARE @AvatarID int;
    SELECT @AvatarID = GroupAvatarID FROM [Community_Group] WHERE GroupID=@GroupID
    IF (@AvatarID > 0)
    BEGIN
      DECLARE @AvatarIsCustom bit;
      SELECT @AvatarIsCustom = AvatarIsCustom FROM [CMS_Avatar]
      IF (@AvatarIsCustom=1)
      BEGIN
	    UPDATE [Community_Group] SET GroupAvatarID=NULL WHERE GroupAvatarID=@AvatarID;
        DELETE FROM [CMS_Avatar] WHERE AvatarID=@AvatarID
      END
    END

	-- Members
	DELETE FROM [Community_GroupMember] WHERE MemberGroupID = @GroupID

	-- Group role permission
	DELETE FROM [Community_GroupRolePermission] WHERE GroupID = @GroupID

	-- Forums
	UPDATE [Forums_ForumPost] SET PostParentID=NULL WHERE PostForumId IN (
			SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
			SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupGroupID = @GroupID
		));
	DELETE FROM [Forums_ForumSubscription] WHERE SubscriptionPostID IN (
			SELECT PostID FROM Forums_ForumPost WHERE (PostForumID  IN (
			SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
			SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupGroupID = @GroupID
		))));
	DELETE FROM [Forums_UserFavorites] WHERE PostID IN (
			SELECT PostID FROM [Forums_ForumPost] WHERE ( PostForumId IN (  
			SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
			SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupGroupID = @GroupID
		))));
	DELETE FROM [Forums_UserFavorites] WHERE ForumID IN (
			SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
			SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupGroupID = @GroupID
		));
	DELETE FROM [Forums_Attachment] WHERE AttachmentPostID IN (
			SELECT PostID FROM [Forums_ForumPost] WHERE ( PostForumId IN (  
			SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
			SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupGroupID = @GroupID
		))));	
	DELETE FROM [Forums_ForumPost] WHERE PostForumId IN (
			SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
			SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupGroupID = @GroupID
		));
	DELETE FROM [Forums_ForumRoles ] WHERE ForumId IN (
			SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
			SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupGroupID = @GroupID
		));
	DELETE FROM [Forums_ForumModerators] WHERE ForumID IN (
			SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
			SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupGroupID = @GroupID
		));
	DELETE FROM [Forums_ForumSubscription] WHERE SubscriptionForumId IN (
			SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
			SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupGroupID = @GroupID
		));
	DELETE FROM [Forums_Forum] WHERE ForumGroupId IN (
			SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupGroupID = @GroupID
		);
	DELETE FROM Forums_ForumGroup WHERE GroupGroupID = @GroupID;

	-- Polls
	DELETE FROM [Polls_PollRoles] WHERE PollID IN (
			SELECT PollID FROM [Polls_Poll] WHERE PollGroupID = @GroupID
		);
	DELETE FROM [Polls_PollSite] WHERE PollID IN (
			SELECT PollID FROM [Polls_Poll] WHERE PollGroupID = @GroupID
		);
	DELETE FROM [Polls_PollAnswer] WHERE AnswerPollID IN (
			SELECT PollID FROM [Polls_Poll] WHERE PollGroupID = @GroupID
		);
	DELETE FROM [Polls_Poll] WHERE PollGroupID = @GroupID;

	-- Roles
	DELETE FROM [CMS_UserRole] WHERE RoleID IN (
			SELECT RoleID FROM [CMS_Role] WHERE RoleGroupID = @GroupID
		);
	DELETE FROM [CMS_RolePermission] WHERE RoleID IN (
			SELECT RoleID FROM [CMS_Role] WHERE RoleGroupID = @GroupID
		);

	DELETE FROM [CMS_ACLItem] WHERE RoleID IN (
			SELECT RoleID FROM [CMS_Role] WHERE RoleGroupID = @GroupID
		);

	DELETE FROM [CMS_WorkflowStepRoles] WHERE RoleID IN (
			SELECT RoleID FROM [CMS_Role] WHERE RoleGroupID = @GroupID
		);

    DELETE FROM [FORUMS_ForumRoles] WHERE RoleID IN (
			SELECT RoleID FROM [CMS_Role] WHERE RoleGroupID = @GroupID
		);

	DELETE FROM [Polls_PollRoles] WHERE RoleID IN (
			SELECT RoleID FROM [CMS_Role] WHERE RoleGroupID = @GroupID
		);

	DELETE FROM [Board_Role] WHERE RoleID IN (
			SELECT RoleID FROM [CMS_Role] WHERE RoleGroupID = @GroupID
		);

	DELETE FROM [CMS_Role] WHERE RoleGroupID = @GroupID;

	-- Group message boards
    DELETE FROM Board_Message WHERE MessageBoardID IN ( SELECT BoardID FROM Board_Board WHERE BoardGroupID = @GroupID );
	DELETE FROM Board_Moderator WHERE BoardID IN ( SELECT BoardID FROM Board_Board WHERE BoardGroupID = @GroupID );
	DELETE FROM Board_Role WHERE BoardID IN ( SELECT BoardID FROM Board_Board WHERE BoardGroupID = @GroupID );
	DELETE FROM Board_Subscription WHERE SubscriptionBoardID IN (SELECT BoardID FROM Board_Board WHERE BoardGroupID = @GroupID);
	DELETE FROM Board_Board WHERE BoardGroupID = @GroupID;

	-- Group invitation
	DELETE FROM Community_Invitation WHERE InvitationGroupID = @GroupID;

	-- Remove refrences to the tree node
	UPDATE CMS_TREE SET NodeGroupID = NULL WHERE NodeGroupID = @GroupID;

END
GO


DECLARE @classId int;
SET @classId = (SELECT TOP 1 ClassID FROM CMS_Class WHERE ClassName = N'CMS.DocumentAlias')
IF @classId <>0 BEGIN

UPDATE CMS_Query SET QueryText = 'SELECT ##COLUMNS## FROM CMS_DocumentAlias INNER JOIN CMS_Tree ON CMS_DocumentAlias.AliasNodeID = CMS_Tree.NodeID WHERE (@WildcardRule=AliasURLPath OR @WildcardRule LIKE CMS_DocumentAlias.AliasWildcardRule) AND CMS_Tree.NodeSiteID = @SiteID ORDER BY AliasPriority' WHERE ClassID=@classId AND QueryName='selectbywildcardrule'

END
GO

-- Remove staging tasks for document aliases
DELETE FROM Staging_SyncLog WHERE (SyncLogTaskID IN (SELECT TaskID FROM Staging_Task WHERE (TaskObjectType = 'cms.documentalias')))
DELETE FROM Staging_Synchronization WHERE (SynchronizationTaskID IN (SELECT TaskID FROM Staging_Task WHERE (TaskObjectType = 'cms.documentalias')))
DELETE FROM Staging_Task WHERE (TaskObjectType = 'cms.documentalias')
GO


-- Update CMS.DocumentAlias.selectbywildcardrule query due to underscore characters
DECLARE @classId int;
SET @classId = (SELECT TOP 1 ClassID FROM CMS_Class WHERE ClassName = N'CMS.DocumentAlias')
IF @classId <>0 BEGIN

UPDATE CMS_Query SET QueryText = 'SELECT ##COLUMNS## FROM CMS_DocumentAlias INNER JOIN CMS_Tree ON CMS_DocumentAlias.AliasNodeID = CMS_Tree.NodeID WHERE (@UrlPath=AliasURLPath OR @WildcardRule LIKE CMS_DocumentAlias.AliasWildcardRule) AND CMS_Tree.NodeSiteID = @SiteID ORDER BY AliasPriority' WHERE ClassID=@classId AND QueryName='selectbywildcardrule'

END 
GO